
process equationSolving =
     ( ? real a;
         real b;
         real c;
       ! real x2;
         real x1;
         boolean oc;
     )
  (|  ( err, x21, x2, stable, L277_PREDICATE, L283_PREDICATE, C_x, C_CLK_339) := SecondDegree_ABS( when (a/=0.0) , a, b, c)
   | (x, err2) := FirstDegree( (a = 0.0) , b, c)
   | x1 := x21 default x
   | oc := (when err) default err2
   | a ^= b ^= c
   |)
  where 
    constant real cst_epsilon = 0.0001;
    boolean stable, L277_PREDICATE, L283_PREDICATE, C_x, C_CLK_339, err2, err;
    real x21, x;

   process FirstDegree =
        ( ? boolean Compute;
            real b;
            real c;
          ! real x;
            boolean err2;
        )
      (| (| (| (| c := cc_2
                | b := bb_1
                | (| bb := b when (b/=0.0)
                   | cc := c when (b/=0.0)
                   | x := -(cc/bb)
                   |)
                |)/ cc, bb |) where real b, c; end
          | (| c := cc_2
             | b := bb_1
             | error := (c/=0.0) when (b=0.0)
             | err2 := error
             |) where boolean error;
                      real b, c; end
          | (| (| bb := b when Compute
                | cc := c when Compute
                |)
             | bb_1 := bb
             | cc_2 := cc
             |) where real bb, cc; end
          |)/ cc_2, bb_1 |)
      where 
      real bb, cc, bb_1, cc_2;
      end
   ; 
    
    
process SecondDegree_ABS =
     ( ? boolean OK; 
         real a, b, c;
       ! boolean err; 
         real x21, x2; 
         boolean stable, L277_PREDICATE, L283_PREDICATE, C_x, C_CLK_339;
     )
   pragmas 
      GreyBox "SecondDegree"
   end pragmas
   (| (| (| stable ^= L283_PREDICATE ^= C_x ^= C_CLK_339 ^= Tick
          | [:C_x] ^= x21
          | [:stable] ^= a ^= b ^= c
          | [:L283_PREDICATE] ^= x2
          | [/:a=0.0] ^= OK ^= L277_PREDICATE
          | [:L277_PREDICATE] ^= err
          |) |)
    | (| L351_nlabel :: (err, x21, x2, L277_PREDICATE, L283_PREDICATE, C_x, C_CLK_339) := SecondDegree_Cluster_1()
       | L351_nlabel ^= [:Tick]
       |)
    | (| L352_nlabel :: SecondDegree_Cluster_2(c)
       | L352_nlabel ^= [:stable]
       |)
    | (| L353_nlabel :: SecondDegree_Cluster_3(b)
       | L353_nlabel ^= [:stable]
       |)
    | (| L354_nlabel :: SecondDegree_Cluster_4(a)
       | L354_nlabel ^= [:Tick]
       |)
    | (| L380_nlabel :: stable := SecondDegree_STATES()
       | L380_nlabel ^= [:Tick]
       |)
    | (| OK --> L351_nlabel
       | c --> L351_nlabel
       | b --> L351_nlabel
       | a --> L351_nlabel
       | L352_nlabel --> L353_nlabel
       | L352_nlabel --> L351_nlabel
       | c --> L352_nlabel
       | L353_nlabel --> L351_nlabel
       | b --> L353_nlabel
       | L354_nlabel --> L353_nlabel
       | L354_nlabel --> L352_nlabel
       | L354_nlabel --> L351_nlabel
       | c --> L354_nlabel
       | a --> L354_nlabel
       | L354_nlabel --> L380_nlabel
       | L353_nlabel --> L380_nlabel
       | L352_nlabel --> L380_nlabel
       | L351_nlabel --> L380_nlabel
       |)
    |)
   where 
   event Tick; 
   label L351_nlabel, L352_nlabel, L353_nlabel, L354_nlabel, L380_nlabel; 
   action SecondDegree_Cluster_1 =
        ( ! boolean err; 
            real x21; 
            real x2; 
            boolean L277_PREDICATE; 
            boolean L283_PREDICATE; 
            boolean C_x; 
            boolean C_CLK_339;
        )
      pragmas 
         Cluster {a,b,c}
         BlackBox ""
      end pragmas
      external "C"
   ; 
   action SecondDegree_Cluster_2 =
        ( ? real c;
        )
      pragmas 
         Cluster {a,c}
         BlackBox ""
      end pragmas
      external "C"
   ; 
   action SecondDegree_Cluster_3 =
        ( ? real b;
        )
      pragmas 
         Cluster {a,b}
         BlackBox ""
      end pragmas
      external "C"
   ; 
   action SecondDegree_Cluster_4 =
        ( ? real a;
        )
      pragmas 
         Cluster {a}
         BlackBox ""
      end pragmas
      external "C"
   ; 
   action SecondDegree_STATES =
        ( ! boolean stable init true;
        )
      pragmas 
         DelayCluster
         Cluster
         BlackBox ""
      end pragmas
      external "C"
   ;
   end
; 
     
   end
; 
