/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#ifndef pK_IOSTD_H
#define pK_IOSTD_H

#define pK_PRINT(s) printf(s)

/* Integer */
#define pK_READint(x) { if (scanf("%d", &x)!=1) return pk_false; }
#define pK_WRITEint(s)  printf("%d\n", s)

#define pK_READshort(x)  pK_READint(x)
#define pK_WRITEshort(s)  pK_WRITEint(s)

#define pK_READlong(x)  { if (scanf("%ld", &x)!=1) return pk_false; }
#define pK_WRITElong(s)  printf("%ld\n", s)


#define pK_WRITElogical(s) (s ? printf("True\n") : printf("False\n"))
#define pK_READlogical(s) pK_READint(s)

#define pK_READfloat(x) { if (scanf("%f", &x)!=1) return pk_false; }
#define pK_WRITEfloat(s)  printf("%f\n", s)

#define pK_READdouble(x) { if (scanf("%lf", &x)!=1) return pk_false; }
#define pK_WRITEdouble(s)  printf("%lf\n", s)


#define pK_READpK_String(x) { if (scanf("%s", &x)!=1) return pk_false; }
#define pK_WRITEpK_String(s)  printf("%s\n", s)

#define pK_READchar(x) { if (scanf("%c", &x)!=1) return pk_false; getchar();}
#define pK_WRITEchar(s)  printf("%c\n", s)


/* Complex */
#define pK_READpK_complex(x) { if (scanf("%f", &x.re)!=1) return pk_false; if (scanf("%f", &x.im)!=1) return pk_false;}
#define pK_WRITEpK_complex(s)  printf("(%f, %f)\n", s.re, s.im);

#define pK_READpK_complexd(x) { if (scanf("%lf", &x.re)!=1) return pk_false; if (scanf("%lf", &x.im)!=1) return pk_false;}
#define pK_WRITEpK_complexd(s)  printf("(%lf, %lf)\n", s.re, s.im);


#endif
